    001    /* ========================================================================
    002     * JCommon : a free general purpose class library for the Java(tm) platform
    003     * ========================================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jcommon/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * -----------------------
    028     * NumberCellRenderer.java
    029     * -----------------------
    030     * (C) Copyright 2000-2004, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: NumberCellRenderer.java,v 1.7 2007/11/02 17:50:36 taqua Exp $
    036     *
    037     * Changes (from 26-Oct-2001)
    038     * --------------------------
    039     * 26-Oct-2001 : Changed package to com.jrefinery.ui.*;
    040     * 11-Mar-2002 : Updated import statements (DG);
    041     *
    042     */
    043
    044    package org.jfree.ui;
    045
    046    import java.awt.Component;
    047    import java.text.NumberFormat;
    048    import javax.swing.JTable;
    049    import javax.swing.SwingConstants;
    050    import javax.swing.table.DefaultTableCellRenderer;
    051
    052    /**
    053     * A table cell renderer that formats numbers with right alignment in each cell.
    054     *
    055     * @author David Gilbert
    056     */
    057    public class NumberCellRenderer extends DefaultTableCellRenderer {
    058
    059        /**
    060         * Default constructor - builds a renderer that right justifies the
    061         * contents of a table cell.
    062         */
    063        public NumberCellRenderer() {
    064            super();
    065            setHorizontalAlignment(SwingConstants.RIGHT);
    066        }
    067
    068        /**
    069         * Returns itself as the renderer. Supports the TableCellRenderer interface.
    070         *
    071         * @param table  the table.
    072         * @param value  the data to be rendered.
    073         * @param isSelected  a boolean that indicates whether or not the cell is
    074         *                    selected.
    075         * @param hasFocus  a boolean that indicates whether or not the cell has
    076         *                  the focus.
    077         * @param row  the (zero-based) row index.
    078         * @param column  the (zero-based) column index.
    079         *
    080         * @return the component that can render the contents of the cell.
    081         */
    082        public Component getTableCellRendererComponent(final JTable table,
    083                final Object value, final boolean isSelected,
    084                final boolean hasFocus, final int row, final int column) {
    085
    086            setFont(null);
    087            final NumberFormat nf = NumberFormat.getNumberInstance();
    088            if (value != null) {
    089              setText(nf.format(value));
    090            }
    091            else {
    092              setText("");
    093            }
    094            if (isSelected) {
    095                setBackground(table.getSelectionBackground());
    096            }
    097            else {
    098                setBackground(null);
    099            }
    100            return this;
    101        }
    102
    103    }